// #autoload
// #name = CokeHaveFlagHud
// #version = 1.0
// #date = March 28, 2002
// #author = ]E[ Coke
// #warrior = Coke
// #email = austinpowers69r@hotmail.com
// #web = http://coke.teamentropy.net
// #description = Friendly reminder that you have the enemy flag
// #status = beta
// #include = support/team_tracker.cs
// #include = support/callback.cs
// #include = support/stat_support.cs
// #credit = mrpoop, uberguy

//msg you want flashed on screen
$MSG = "Enemy Flag!";
//color 1 - First color flashed
$color1 = "00FF00";
//color 2 - Second color flashed
$color2 = "FFFFFF";

if (!isObject(CokeFlag)) {
	new ScriptObject(CokeFlag) {
		class = CokeFlag;
		haveKit = false;
		armed = false;
		gotKit = false;
		triggered = false;
		playerID = 0;
		useCheckID = 0;
		blinkDelay = 300;
		blinkTime = 3000;
	};
}
  	function  ToggleFlagHud( %val ) {
		if( %val ) {
        		if( $pref::CokeFlagHud ) {
		                $pref::CokeFlagHud = false;
				%messageoff = "\c2CokeFlagHud [\c4OFF\c2]";
                CokeFlagHudDestroy();
		                addMessageHudLine( %messageoff );
			} else {
		                $pref::CokeFlagHud = true;
				%messageon = "\c2CokeFlagHud [\c4ON\c2]";
    					CokeFlagHudCreate();
                        playGui.add(CokeFlagHud);
                        CokeFlag.activate();
                        CokeFlagHud.setVisible(true);
		                addMessageHudLine( %messageon );
			}
		}
        	export("$pref::CokeFlagHud", "prefs/ClientPrefs.cs", False);
	}
function HaveFlag(%clientid, %flagteam) {
    //loop 2 different colors :>
   	if (%clientid == teamTracker.myID){
    $haveflag = true;
    $color = true;
    LoopFlag();
    }
	//CokeFlagHud.displayMsg(found,"<color:00FF00>You Have the Enemy Flag!");
}
function LoopFlag(%this) {
    //loop 2 different colors :>
    if($haveflag == true){
    if($color == true){
	CokeFlagHud.displayMsg(found,"<color:" @ $color1 @ ">" @ $MSG);
    $color=false;
    } else {
    CokeFlagHud.displayMsg(found,"<color:" @ $color2 @ ">" @ $MSG);
    $color=true;
    }
    schedule(500, 0, LoopFlag);
    }
}

function DroppedFlag(%clientid, %flagteam) {
//make the message dissapear
if (%clientid == teamTracker.myID) {
$haveflag=false;
CokeFlagHUDText.setText(" ");
}

}
function CokeFlag::activate(%this) {

 	callback.add(onFlagGrab, HaveFlag);
	callback.add(onFlagDrop, DroppedFlag);
    callback.add(onFlagCap, DroppedFlag);
  	callback.add(onMatchStart, DroppedFlag);
    callback.add(onMatchEnd, DroppedFlag);

	activatePackage(CokeFlagPkg);

	if (isObject(HM) && isObject(HudMover))
		hudmover::addhud(CokeFlagHud, "CokeFlag Hud");
}


function CokeFlagHud::displayMsg(%this, %type, %msg) {

	%this.setVisible(true);
	CokeFlagHUDText.setText("<just:center>" @ %msg);
	//CokeFlagHUDText.blink(true);
    //%this.schedID = %this.schedule(CokeFlag.blinkTime,hide);
}

function CokeFlagHudDestroy() {
		if (isObject(CokeFlagHud)) {
			playGui.remove(CokeFlagHud);
			CokeFlagHud.delete();
		}
}

function CokeFlagGui::onWake(%this) {}

package CokeFlagPkg {

	function throw(%item) {

		if (%item $= "RepairKit" && loadout.getRepairKit()) {
			CokeFlagHud.displayMsg(dropped,"<color:FF0000>No Kit");
		}
		parent::throw(%item);
	}

	function OptionsDlg::onWake(%this)	{

		if (!$CokeFlag::options) {
			$RemapName[$RemapCount] = "Toggle CokeFlagHud";
			$RemapCmd[$RemapCount] = "ToggleFlagHud";
			$RemapCount++;
			$CokeFlag::options = true;
		}
		parent::onWake(%this);
	}

	function PlayGui::onWake(%this) {
		if (!PlayGui.isMember(CokeFlagHud)) PlayGui.add(CokeFlagHud);
		parent::onWake(%this);
	}
};

if (!isObject(CokeFlagHudProfile)) {
	new GuiControlProfile ("CokeFlagHudProfile") {
		fontType = "Univers Bold";
		fontSize = 16;
		fontColor = "255 255 255";
  //transparent
	};
	new GuiControlProfile ("CokeFlagHudProfile2") {
		fontType = "Univers Bold";
		fontSize = 16;
		fontColor = "255 255 255";
		bitmapbase = "gui/hud_new_window";
  //not transparent
	};
}
function CokeFlagHudCreate(){
CokeFlagHudDestroy();
if (!isObject(CokeFlagHud)) {
	new ShellFieldCtrl(CokeFlagHUD) {
		profile = "CokeFlagHudProfile";
		horizSizing = "relative";
		vertSizing = "center";
		position = "448 329";
        //position = %extentX @ " " @ (%posY+20);
		extent = "250 22";
		minExtent = "8 8";
		visible = "0";
		helpTag = "0";

		new GuiMLTextCtrl(CokeFlagHUDText) {
			profile = "CokeFlagHudProfile";
			horizSizing = "center";
			vertSizing = "top";
			position = "0 0";
			extent = "250 22";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
		};
	};
 
 }
 }
package RespawnCheck{

        function DispatchLaunchMode() {
	       parent::DispatchLaunchMode();
         if($pref::CokeFlagHud)
        	CokeFlagHudCreate();
        }
        function clientCmdTogglePlayHuds(%val)
        {
	       parent::clientCmdTogglePlayHuds(%val);
           if($pref::CokeFlagHud)
	       CokeFlagHud.setVisible(%val);
        }
        function quit()
	    {
        CokeFlagHUDText.setText(" ");
		parent::quit();
	    }
};
CokeFlag.activate();
activatePackage(RespawnCheck);
